<?php defined('SYSPATH') or die('No direct script access.');

class Model_Teachers extends Model
{
    public static function create() {
        return new self();
    }

    public function getFaculties() {
        $sql = "CALL `GetFaculties`(); ";
        return DB::query(Database::SELECT, $sql)->execute();
    }

    public function getJobPositions() {
        $sql = "CALL `GetJobPositions`(); ";
        return DB::query(Database::SELECT, $sql)->execute();
    }

    public function getTeachersForDiscipline($disciplineID) {
        $sql = "CALL `GetTeachersForDiscipline`('$disciplineID'); ";
        return DB::query(Database::SELECT, $sql)->execute();
    }

    public function getTeachersByFaculty($facultyID) {
        $sql = "CALL `GetTeachersByFaculty`('$facultyID'); ";
        return DB::query(Database::SELECT, $sql)->execute();
    }

    public function byFaculty($facultyID) {
        $list = array();

        if ($facultyID != 0) {
            $teachers = $this->getTeachersByFaculty($facultyID);

            foreach ($teachers as $row) {
                $row['DepartmentID'] = $row['DepID'];
                $row['DepartmentName'] = $row['DepName'];
                $list[] = $row;
            }
        }

        return new DataArray_Result($list);
    }

    public function byDepartment($departmentID) {
        $teachers = $this->getTeachersByDepartment($departmentID);
        $list = array();

        foreach ($teachers as $row) {
            $row['DepartmentName'] = $row['DepName'];
            $list[] = $row;
        }

        return new DataArray_Result($list);
    }

    public function forDiscipline($disciplineID, $asConcat = false, $asInitials = false) {
        $teachers = $this->getTeachersForDiscipline($disciplineID);
        $list = array();

        foreach ($teachers as $row) {
            if ($asInitials) {
                $row['FirstName'] = UTF8::substr($row['FirstName'], 0, 1) . '. ';
                if (!empty($row['SecondName']))
                    $row['SecondName'] = UTF8::substr($row['SecondName'], 0, 1) . '. ';
            }

            if ($asConcat)
                $list[] = $row['LastName'] . $row['FirstName'] . $row['SecondName'];
            else
                $list[] = $row;
        }

        return new DataArray_Result($list);
    }

    public function getTeachersByDepartment($departmentID) {
        $sql = "CALL `GetTeachersByDepartment`('$departmentID'); ";
        return DB::query(Database::SELECT, $sql)->execute();
    }

    public function getDepartmentsByFaculty($facultyID) {
        $sql = "CALL `GetDepartments`('$facultyID'); ";
        return DB::query(Database::SELECT, $sql)->execute();
    }

    public function searchTeachers($FacultyID, $DepartmentID, $Last, $First, $Second) {
        $db = Database::instance();
        $Last = $db->escape($Last);
        $Second = $db->escape($Second);
        $First = $db->escape($First);
        $sql = "CALL `SearchTeachers`('$FacultyID', '$DepartmentID', $Last, $First, $Second); ";
        return DB::query(Database::SELECT, $sql)->execute();
    }

    public function searchTeacherNew($FacultyID, $DepartmentID, $Last, $First, $Second, $DisciplineID) {
        $db = Database::instance();
        $Last = $db->escape($Last);
        $Second = $db->escape($Second);
        $First = $db->escape($First);
        $sql = "CALL `SearchTeacherNew`('$FacultyID', '$DepartmentID', $Last, $First, $Second, '$DisciplineID'); ";
        return DB::query(Database::SELECT, $sql)->execute();
    }
}